<template>
  <a-list-layout ref="pageRef">
    <template #search>
      <pro-query :searchParam="searchParam" @on-search="search"></pro-query>
    </template>
    <pro-table ref="tableRef" :fetch="fetch" :columns="columns" :toolbar="toolbar" :operate="operate"
      :param="state.param" :pagination="pagination"
      :row-selection="{ selectedRowKeys: state.selectedRowKeys, onChange: onSelectChange }">
    </pro-table>
    <save :visible="state.visibleSave" @close="closeSave"></save>
    <edit :visible="state.visibleEdit" @close="closeEdit" :record="state.recordEdit"></edit>
    <info :visible="state.visibleInfo" @close="closeInfo" :record="state.recordInfo"></info>
  </a-list-layout>
</template>

<script>
import save from './modal/save.vue';
import edit from './modal/edit.vue';
import info from './modal/info.vue';
import { message, Modal as modal } from '@hwork/ant-design-vue';
import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
import { page, remove, removeBatch } from "@/api/module/post";
import { reactive, createVNode, ref } from 'vue';

const removeKey = "remove";
const removeBatchKey = "removeBatch";

export default {
  components: {
    save,
    edit,
    info,
  },
  setup() {

    const tableRef = ref();

    /// 开关
    const switchFormat = { yes: true, no: false };

    /// 列配置
    const columns = [
      { dataIndex: "index", key: "index", title: "序号", width: 60, fixed: 'left', align: 'center' },
      { dataIndex: "name", key: "name", title: "名称" },
      { dataIndex: "code", key: "code", title: "标识" },
      { dataIndex: "remark", key: "remark", title: "备注" },
      { dataIndex: "enable", key: "enable", title: "状态", switch: switchFormat },
      { dataIndex: "sort", key: "sort", title: "排序" },
    ];

    /// 数据来源 [模拟]
    const fetch = async (param) => {
      var response = await page(param);
      return {
        total: response.data.total,
        data: response.data.record,
      };
    };

    /// 删除配置
    const removeMethod = (record) => {
      modal.confirm({
        title: '您是否确定要删除此配置?',
        icon: createVNode(ExclamationCircleOutlined),
        okText: '确定',
        cancelText: '取消',
        onOk() {
          message.loading({ content: "提交中...", key: removeKey });
          remove({ "id": record.id }).then((response) => {
            if (response.success) {
              message.success({ content: "删除成功", key: removeKey, duration: 1 }).then(() => {
                tableRef.value.reload()
              })
            } else {
              message.error({ content: "删除失败", key: removeKey, duration: 1 })
            }
          })
        }
      });
    }

    const removeBatchMethod = (ids) => {
      modal.confirm({
        title: '您是否确定要删除选择配置?',
        icon: createVNode(ExclamationCircleOutlined),
        okText: '确定',
        cancelText: '取消',
        onOk() {
          message.loading({ content: "提交中...", key: removeBatchKey });
          removeBatch({ "ids": ids }).then((response) => {
            if (response.success) {
              message.success({ content: "删除成功", key: removeBatchKey, duration: 1 }).then(() => {
                tableRef.value.reload()
              })
            } else {
              message.error({ content: "删除失败", key: removeBatchKey, duration: 1 })
            }
          })
        }
      });
    }

    /// 工具栏
    const toolbar = [
      { label: "新增", icon: 'PlusOutlined', event: function () { state.visibleSave = true } },
      { label: "删除", icon: 'DeleteOutlined', danger: true,event: function () { removeBatchMethod(state.selectedRowKeys) } },
    ];

    /// 行操作
    const operate = [
      { label: "查看", event: function (record) { state.visibleInfo = true, state.recordInfo = record } },
      { label: "修改", event: function (record) { state.visibleEdit = true, state.recordEdit = record } },
      { label: "删除", isDel: true, event: function (record) { removeMethod(record) } },
    ];

    /// 分页参数
        const pagination = {
        pageNum: 1,
        pageSize: 20,
        showSizeChanger: true, // 显示可改变每页条数
        pageSizeOptions: ["10", "20", "50", "100"], // 每页条数选项设置
        showTotal: total => `共 ${total} 条记录`, // 显示总条数
        showSizeChange: (current, pageSize) => (this.pageSize = pageSize) // 改变每页条数时更新显示
      }

    /// 外置参数 - 当参数改变时, 重新触发 fetch 函数
    const state = reactive({
      selectedRowKeys: [],
      param: {},
      visibleSave: false,
      visibleEdit: false,
      visibleInfo: false,
      recordEdit: {},
      recordInfo: {},
    })

    const searchParam = [
      { key: "name", type: "input", label: "岗位名称" },
      { key: "code", type: "input", label: "岗位编码" },
    ]

    const search = function (value) {
      state.param = value
      tableRef.value.reload()
    }

    const closeSave = function () {
      state.visibleSave = false
      tableRef.value.reload()
    }

    const closeEdit = function () {
      state.visibleEdit = false
      tableRef.value.reload()
    }

    const closeInfo = function () {
      state.visibleInfo = false
    }

    const onSelectChange = selectedRowKeys => {
      state.selectedRowKeys = selectedRowKeys;
    };

    return {
      state,
      fetch,
      search,
      toolbar,
      columns,
      operate,
      pagination,
      searchParam,
      onSelectChange,

      closeSave,
      closeEdit,
      closeInfo,

      tableRef
    };
  },
};
</script>
